// Code generated by go-swagger; DO NOT EDIT.

package networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/skupperproject/skupper/client/generated/libpod/models"
)

// NewNetworkCreateLibpodParams creates a new NetworkCreateLibpodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkCreateLibpodParams() *NetworkCreateLibpodParams {
	return &NetworkCreateLibpodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkCreateLibpodParamsWithTimeout creates a new NetworkCreateLibpodParams object
// with the ability to set a timeout on a request.
func NewNetworkCreateLibpodParamsWithTimeout(timeout time.Duration) *NetworkCreateLibpodParams {
	return &NetworkCreateLibpodParams{
		timeout: timeout,
	}
}

// NewNetworkCreateLibpodParamsWithContext creates a new NetworkCreateLibpodParams object
// with the ability to set a context for a request.
func NewNetworkCreateLibpodParamsWithContext(ctx context.Context) *NetworkCreateLibpodParams {
	return &NetworkCreateLibpodParams{
		Context: ctx,
	}
}

// NewNetworkCreateLibpodParamsWithHTTPClient creates a new NetworkCreateLibpodParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkCreateLibpodParamsWithHTTPClient(client *http.Client) *NetworkCreateLibpodParams {
	return &NetworkCreateLibpodParams{
		HTTPClient: client,
	}
}

/*
NetworkCreateLibpodParams contains all the parameters to send to the API endpoint

	for the network create libpod operation.

	Typically these are written to a http.Request.
*/
type NetworkCreateLibpodParams struct {

	/* Create.

	   attributes for creating a network
	*/
	Create *models.SwagNetworkCreateLibpod

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network create libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkCreateLibpodParams) WithDefaults() *NetworkCreateLibpodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network create libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkCreateLibpodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the network create libpod params
func (o *NetworkCreateLibpodParams) WithTimeout(timeout time.Duration) *NetworkCreateLibpodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network create libpod params
func (o *NetworkCreateLibpodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network create libpod params
func (o *NetworkCreateLibpodParams) WithContext(ctx context.Context) *NetworkCreateLibpodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network create libpod params
func (o *NetworkCreateLibpodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network create libpod params
func (o *NetworkCreateLibpodParams) WithHTTPClient(client *http.Client) *NetworkCreateLibpodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network create libpod params
func (o *NetworkCreateLibpodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCreate adds the create to the network create libpod params
func (o *NetworkCreateLibpodParams) WithCreate(create *models.SwagNetworkCreateLibpod) *NetworkCreateLibpodParams {
	o.SetCreate(create)
	return o
}

// SetCreate adds the create to the network create libpod params
func (o *NetworkCreateLibpodParams) SetCreate(create *models.SwagNetworkCreateLibpod) {
	o.Create = create
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkCreateLibpodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Create != nil {
		if err := r.SetBodyParam(o.Create); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
