// Code generated by go-swagger; DO NOT EDIT.

package networks

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewNetworkInspectLibpodParams creates a new NetworkInspectLibpodParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkInspectLibpodParams() *NetworkInspectLibpodParams {
	return &NetworkInspectLibpodParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkInspectLibpodParamsWithTimeout creates a new NetworkInspectLibpodParams object
// with the ability to set a timeout on a request.
func NewNetworkInspectLibpodParamsWithTimeout(timeout time.Duration) *NetworkInspectLibpodParams {
	return &NetworkInspectLibpodParams{
		timeout: timeout,
	}
}

// NewNetworkInspectLibpodParamsWithContext creates a new NetworkInspectLibpodParams object
// with the ability to set a context for a request.
func NewNetworkInspectLibpodParamsWithContext(ctx context.Context) *NetworkInspectLibpodParams {
	return &NetworkInspectLibpodParams{
		Context: ctx,
	}
}

// NewNetworkInspectLibpodParamsWithHTTPClient creates a new NetworkInspectLibpodParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkInspectLibpodParamsWithHTTPClient(client *http.Client) *NetworkInspectLibpodParams {
	return &NetworkInspectLibpodParams{
		HTTPClient: client,
	}
}

/*
NetworkInspectLibpodParams contains all the parameters to send to the API endpoint

	for the network inspect libpod operation.

	Typically these are written to a http.Request.
*/
type NetworkInspectLibpodParams struct {

	/* Name.

	   the name of the network
	*/
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network inspect libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkInspectLibpodParams) WithDefaults() *NetworkInspectLibpodParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network inspect libpod params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkInspectLibpodParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the network inspect libpod params
func (o *NetworkInspectLibpodParams) WithTimeout(timeout time.Duration) *NetworkInspectLibpodParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network inspect libpod params
func (o *NetworkInspectLibpodParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network inspect libpod params
func (o *NetworkInspectLibpodParams) WithContext(ctx context.Context) *NetworkInspectLibpodParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network inspect libpod params
func (o *NetworkInspectLibpodParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network inspect libpod params
func (o *NetworkInspectLibpodParams) WithHTTPClient(client *http.Client) *NetworkInspectLibpodParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network inspect libpod params
func (o *NetworkInspectLibpodParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the network inspect libpod params
func (o *NetworkInspectLibpodParams) WithName(name string) *NetworkInspectLibpodParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the network inspect libpod params
func (o *NetworkInspectLibpodParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkInspectLibpodParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
